/* The use.
 * This script is made for use in conjunction with three programs:
 * 1. glp.dll (Gateway Library Parent)
 * 2. glc.exe (Gateway Library Child)
 * 3. mtt.jar (Mobile Trading Terminal)
 * To use glp.dll & glc.exe you should put them in your "\Meta Trader 4\" directory.
 * To use mtt.jar you should copy it into your mobile device, IP & java midlets
 * with support of MIDP 2.0 & CLDC 1.1 (for floating point numbers) enabled.
 * To launch the project you should execute the II.mq4 script on the chart in Meta Trader terminal.
 * When you do this the script launches the glp.dll, then the glp.dll launches glc.exe
 * which is the server program. To use the glc.exe properly you should lease public IP address 
 * from your internet provider. It is necessary for the server program to be in view from
 * global network. If you use router or firewall you should write the port number ("36895" by default) 
 * in their configurations and here in the II.mq4 script.
 * When server program is running you see the empty command window. All program responses you see in
 * the Meta Trader expert tab. 
 * When you launch the mtt.jar in your mobile device you see the URL text box. There you should write
 * your public IP:port number. In the Refresh Interval text box you should write
 * the interval of data refreshing in seconds.
 * With the help of these programs you can see the candles of selected tool, make, change and remove orders.
 * When you change the order you can only change one of three parameters at once (price, take profit, stop loss).
 * In the edit box you should write only the order position number (it is after the order type).
 * These programs make only basic functions. You can use it at your own risk. I accept no responsibility.
 * The project works with Windows 2000. It was not tested with other OS.
 */
 
#include <stderror.mqh>
#include <stdlib.mqh>
 
#import "glp.dll"                                               /*"D:\WINDDK\2600~1.110\src\po\m\gl\glp\objfre_wxp_x86\i386\*/
string PipeAndProcessCreation(string PortNumber);
string GlpToII( string Request );
string IIToGlp( string Response );
#import
int start(){
  double RatesArray[][6],price, stoploss, takeprofit;
  int    index, handleRead, handleWrite, CrossPeriod, secondIndex,ticket;
  string DResult, CrossName, SDResult, error, port = "36895";
  DResult = PipeAndProcessCreation(port);
  Print(DResult);
  DResult = GlpToII(" ");
  Print(DResult);
  DResult = GlpToII(" ");
  Print(DResult);
  for(;;){
    index = StringFind(DResult,"OrderModify",0);
    if (index == 0){
      index = StringFind(DResult,"(",0);
      secondIndex = StringFind(DResult,",",index + 1);
      ticket = StrToInteger(StringSubstr(DResult,index+1,secondIndex - index));
      OrderSelect(ticket,SELECT_BY_POS);
      index = StringFind(DResult,",",index + 1);
      secondIndex = StringFind(DResult,",",index + 1);
      price = NormalizeDouble(StrToDouble(StringSubstr(DResult,index+1,secondIndex - index)),MarketInfo(OrderSymbol(),MODE_DIGITS));
      Print("price: ", price);
      index = StringFind(DResult,",",index + 1);
      secondIndex = StringFind(DResult,",",index + 1);
      stoploss = NormalizeDouble(StrToDouble(StringSubstr(DResult,index+1,secondIndex - index)),MarketInfo(OrderSymbol(),MODE_DIGITS));
      Print("stoploss: ", stoploss);      
      index = StringFind(DResult,",",index + 1);
      secondIndex = StringFind(DResult,",",index + 1);
      takeprofit = NormalizeDouble(StrToDouble(StringSubstr(DResult,index+1,secondIndex - index)),MarketInfo(OrderSymbol(),MODE_DIGITS));
      Print("takeprofit: ", takeprofit); 
      if (price > 0)OrderModify(OrderTicket(), price,OrderStopLoss(),OrderTakeProfit(),OrderExpiration());
      if (stoploss > 0)OrderModify(OrderTicket(), OrderOpenPrice(),stoploss,OrderTakeProfit(),OrderExpiration());
      if (takeprofit > 0)OrderModify(OrderTicket(), OrderOpenPrice(),OrderStopLoss(),takeprofit,OrderExpiration());
      error = "Last Error: " + ErrorDescription(GetLastError());
      Print("OrderModify::"+error);
      DResult = IIToGlp(error);
      Print("OrderModify::"+DResult);
      DResult = GlpToII(" ");//Symbol()
      Print("OrderModify::"+DResult);
      DResult = GlpToII(" ");
      Print("OrderModify::"+DResult);       
    }
    index = StringFind(DResult,"OrderSend",0);
    if (index == 0){
      index = StringFind(DResult,"(",0);
      CrossName = StringSubstr(DResult,index+1,6);
      Print("Cross Name: ", CrossName);
      index = StringFind(DResult,",",index + 1);
      secondIndex = StringFind(DResult,",",index + 1);
      int cmd = StrToInteger(StringSubstr(DResult,index+1,secondIndex - index));
      Print("cmd: ", cmd);
      index = StringFind(DResult,",",index + 1);
      secondIndex = StringFind(DResult,",",index + 1);
      double volume = NormalizeDouble(StrToDouble(StringSubstr(DResult,index+1,secondIndex - index)),5);
      Print("volume: ", volume);
      index = StringFind(DResult,",",index + 1);
      secondIndex = StringFind(DResult,",",index + 1);
      price = NormalizeDouble(StrToDouble(StringSubstr(DResult,index+1,secondIndex - index)),MarketInfo(CrossName,MODE_DIGITS));
      Print("price: ", price);
      index = StringFind(DResult,",",index + 1);
      secondIndex = StringFind(DResult,",",index + 1);
      int slippage = StrToInteger(StringSubstr(DResult,index+1,secondIndex - index));
      Print("slippage: ", slippage);
      index = StringFind(DResult,",",index + 1);
      secondIndex = StringFind(DResult,",",index + 1);
      stoploss = NormalizeDouble(StrToDouble(StringSubstr(DResult,index+1,secondIndex - index)),MarketInfo(CrossName,MODE_DIGITS));
      Print("stoploss: ", stoploss);      
      index = StringFind(DResult,",",index + 1);
      secondIndex = StringFind(DResult,",",index + 1);
      takeprofit = NormalizeDouble(StrToDouble(StringSubstr(DResult,index+1,secondIndex - index)),MarketInfo(CrossName,MODE_DIGITS));
      Print("takeprofit: ", takeprofit); 
      index = StringFind(DResult,",",index + 1);
      secondIndex = StringFind(DResult,",",index + 1);
      string comment = StringSubstr(DResult,index+1,secondIndex - index);
      Print("comment: ", comment);
      index = StringFind(DResult,",",index + 1);
      secondIndex = StringFind(DResult,")",index + 1);
      int magic = StrToInteger(StringSubstr(DResult,index+1,secondIndex - index));
      Print("magic: ", magic);
      datetime expiration = 0;//StrToTime(StringSubstr(DResult,index+1,secondIndex - index));
      Print("expiration: ", expiration);
      color arrow_color = Green;//StringSubstr(DResult,index+1,secondIndex - index);
      Print("arrow color: ", arrow_color);
      RefreshRates();
      if(cmd==0)index=OrderSend(CrossName,OP_BUY,volume,MarketInfo(CrossName,MODE_ASK),slippage,stoploss,takeprofit,comment,magic,expiration,arrow_color);
      if(cmd==1)index=OrderSend(CrossName,OP_SELL,volume,MarketInfo(CrossName,MODE_BID),slippage,stoploss,takeprofit,comment,magic,expiration,arrow_color);
      if(cmd==2)index=OrderSend(CrossName,OP_BUYLIMIT,volume,price,slippage,stoploss,takeprofit,comment,magic,expiration,arrow_color);
      if(cmd==3)index=OrderSend(CrossName,OP_SELLLIMIT,volume,price,slippage,stoploss,takeprofit,comment,magic,expiration,arrow_color);
      if(cmd==4)index=OrderSend(CrossName,OP_BUYSTOP,volume,price,slippage,stoploss,takeprofit,comment,magic,expiration,arrow_color);
      if(cmd==5)index=OrderSend(CrossName,OP_SELLSTOP,volume,price,slippage,stoploss,takeprofit,comment,magic,expiration,arrow_color);
      Print("result of OrderSend: ", index);
      error = "Last Error: " + ErrorDescription(GetLastError());
      Print("OrderSend::"+error);
      DResult = IIToGlp(error);
      Print("OrderSend::"+DResult);
      DResult = GlpToII(" ");//Symbol()
      Print("OrderSend::"+DResult);
      DResult = GlpToII(" ");
      Print("OrderSend::"+DResult);
    }
    index = StringFind(DResult,"get_Orders()",0);
    int typeOfOrder;
    if (index == 0){
      int total=OrdersTotal();
      if (total > 0){
        SDResult = "";
        for(int pos=0;pos<total;pos++){
          if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==false) continue;
          typeOfOrder = OrderType();
          if (typeOfOrder == 0) SDResult = SDResult + "BUY: ";
          if (typeOfOrder == 1) SDResult = SDResult + "SELL: ";
          if (typeOfOrder == 2) SDResult = SDResult + "BUYLIMIT: ";
          if (typeOfOrder == 3) SDResult = SDResult + "SELLLIMIT: ";
          if (typeOfOrder == 4) SDResult = SDResult + "BUYSTOP: ";
          if (typeOfOrder == 5) SDResult = SDResult + "SELLSTOP: ";

          SDResult = SDResult + pos /*OrderTicket()*/ + 
                 " Pr: " + DoubleToStr(OrderOpenPrice(),MarketInfo(OrderSymbol(),MODE_DIGITS)) +
                 " SL: " + DoubleToStr(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS)) + 
                 " TP: " + DoubleToStr(OrderTakeProfit(),MarketInfo(OrderSymbol(),MODE_DIGITS));
          SDResult = StringSetChar(SDResult,StringLen(SDResult),10); 
        }
      }else SDResult = "No Orders Exist";
     
      Print("get_Orders()::"+SDResult + "::" + index);
      DResult = IIToGlp(SDResult);
      Print("get_Orders()::"+DResult);
      DResult = GlpToII(" ");
      Print("get_Orders()::"+DResult);
      DResult = GlpToII(" ");
      Print("get_Orders()::"+DResult);
    }
    index = StringFind(DResult,"remove_Order");
    if (index == 0){
      index = StringFind(DResult,"(",0);
      secondIndex = StringFind(DResult,")",index + 1);
      ticket = StrToInteger(StringSubstr(DResult,index+1,secondIndex - index));
      Print(ticket);
      OrderSelect(ticket,SELECT_BY_POS,MODE_TRADES);
      if(OrderDelete(OrderTicket())==false){
        int ordertype = OrderType();
        RefreshRates();
        if (ordertype == OP_BUY || ordertype == OP_BUYLIMIT || ordertype == OP_BUYSTOP)
          OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),0,CLR_NONE);
        else OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),0,CLR_NONE);
      }
      SDResult = "Last error: " + ErrorDescription(GetLastError()) + " Ticket: " + ticket;
      DResult = IIToGlp(SDResult);
      Print("remove_Order::"+DResult);
      DResult = GlpToII(" ");
      Print("remove_Order::"+DResult);
      DResult = GlpToII(" ");
      Print("remove_Order::"+DResult);
    }
    index = StringFind(DResult,"GetHistory",0);
    if (index == 0){
      SDResult = StringSubstr(DResult,index,
                StringLen(DResult)-index);
      Print ( index + "::" + SDResult);
      CrossName = StringSubstr(SDResult,11,6);
      index = StringFind(SDResult,",",18);
      CrossPeriod = StrToInteger(StringSubstr(SDResult,18,index - 18));
      Print(CrossName, " " , CrossPeriod);
      RefreshRates();
      Sleep(1300);
      ArrayCopyRates(RatesArray,CrossName, CrossPeriod);
      index=GetLastError();
      if(index == 4066){
        RefreshRates();
        Sleep(1300);
        ArrayCopyRates(RatesArray,CrossName, CrossPeriod);
      }
      SDResult = "";
      for(int cQ=40; cQ >= 0; cQ--){
        SDResult = SDResult + 
                         "t" + DoubleToStr(RatesArray[cQ][0],0) + 
                         "o" + DoubleToStr(RatesArray[cQ][1],MarketInfo(CrossName,MODE_DIGITS)) + 
                         "l" + DoubleToStr(RatesArray[cQ][2],MarketInfo(CrossName,MODE_DIGITS)) +
                         "h" + DoubleToStr(RatesArray[cQ][3],MarketInfo(CrossName,MODE_DIGITS)) +
                         "c" + DoubleToStr(RatesArray[cQ][4],MarketInfo(CrossName,MODE_DIGITS)) +
                         "v" + DoubleToStr(RatesArray[cQ][5],0) + "/"; 
      }     
      Print("GetHistory::"+SDResult);
      DResult = IIToGlp(SDResult);
      Print("GetHistory::"+DResult);
      DResult = GlpToII(" ");
      Print("GetHistory::"+DResult);
      DResult = GlpToII(" ");
      Print("GetHistory::"+DResult);
    }
    index = StringFind(DResult,"gD",0);
    if (index != -1){
      RefreshRates();
      Sleep(1300);
      ArrayCopyRates(RatesArray,CrossName, CrossPeriod);
      index=GetLastError();
      if(index == 4066){
        RefreshRates();
        Sleep(1300);
        ArrayCopyRates(RatesArray,CrossName, CrossPeriod);
      }
      SDResult =         "t" + DoubleToStr(RatesArray[0][0]/*Time  [0]*/,0) + 
                         //"o" + DoubleToStr(/*RatesArray[0][1]*/Open  [0],5) + 
                         //"l" + DoubleToStr(/*RatesArray[0][2]*/Low   [0],5) +
                         //"h" + DoubleToStr(/*RatesArray[0][3]*/High  [0],5) +
                         "c" + DoubleToStr(RatesArray[0][4]/*Close [0]*//*Bid*/,MarketInfo(CrossName,MODE_DIGITS)) + "/";//Symbol
                         //"v" + DoubleToStr(/*RatesArray[0][5]*/Volume[0],0); 
      Print("gD::" + SDResult + "::" + index);
      DResult = IIToGlp(SDResult);
      Print("gD::" + DResult);
      DResult = GlpToII(" ");
      Print("gD::" + DResult);
      DResult = GlpToII(" ");
      Print("gD::" + DResult);
    }
    index = StringFind(DResult,"Accepted connection",0);
    if (index != -1){
      DResult = GlpToII(" ");
      Print("Accepted connection::"+DResult);
    }
    index = StringFind(DResult,"recv failed",0);
    if (index != -1){
      DResult = GlpToII(" ");
      Print("recv failed::"+DResult);
    }
    index = StringFind(DResult, "GlpToII failed",0);
    if (index !=-1){
      DResult = PipeAndProcessCreation(port);
      Print("GlpToII failed::"+DResult);
      DResult = GlpToII(" ");
      Print("GlpToII failed::"+DResult);
      DResult = GlpToII(" ");
      Print("GlpToII failed::"+DResult);
    }
  }
  return(0);
}

